--
--  Copyright 2012 Anyware Services
--
--  Licensed under the Apache License, Version 2.0 (the "License");
--  you may not use this file except in compliance with the License.
--  You may obtain a copy of the License at
--
--      http://www.apache.org/licenses/LICENSE-2.0
--
--  Unless required by applicable law or agreed to in writing, software
--  distributed under the License is distributed on an "AS IS" BASIS,
--  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
--  See the License for the specific language governing permissions and
--  limitations under the License.
--
drop table if exists Users_Temp;
CREATE TABLE Users_Temp (
  site varchar(255) NOT NULL,
  email varchar(255) NOT NULL,
  population varchar(255) NOT NULL,
  userDirectory varchar(255) NOT NULL,
  firstname varchar(64) NOT NULL,
  lastname varchar(64) NOT NULL,
  subscription_date DATETIME NOT NULL,
  token varchar(128) NOT NULL,
  PRIMARY KEY (site, email),
  UNIQUE KEY token(token)
) ENGINE=innodb;

drop table if exists Users_PasswordChange;
CREATE TABLE Users_PasswordChange (
  site varchar(255) NOT NULL,
  login varchar(255) NOT NULL,
  population varchar(255) NOT NULL,
  request_date DATETIME NOT NULL,
  token varchar(128) NOT NULL,
  PRIMARY KEY(site, login)
) ENGINE=innodb;
